#!/usr/bin/perl
#####################################################################
# File: ~ma/public_html/cgi-bin/grep_pages.cgi
# Author: M.Yamada in Sat Jul 24 17:06:40 JST 1999
# Abstarcs: Perl CGI to grep web pages for the keywords
#
# Last Update: Sun Aug 15 03:01:01 JST 1999
#####################################################################

##
# initializes...
##
$| = 1; # Cache off

@keywords={}; # Default of User Specified Keyword List is EMPTY.
$keywords_N=0; # Number of @keywords
$keyword=""; # Default of User Specified Keyword is NULL.
$all_OR	= 0; # Default of Searching Mode is applied the AND-OPERATOR.
$url=''; # Default of User's Specified URL is NULL.
$url_of_default_url_list
	="http://localhost/~ma/cgi-bin/grep_pages_default_url.lst";
$default_url_list
	= "/home/ma/public_html/cgi-bin/grep_pages_default_url.lst";
$without_URL_list = 0; # Default of Scanning Default URl List is ENABLE.
@targets={}; # Init the target URLs and file paths;
$target_N=0; # Number of targets

##
# Send back the headers
##
print "Content-type: text/html\n\n";
print << "_HTML_";
<html><head><title>Results of "Grep Pages"</title></head>
<body><table width=90%><tr><td>
<h1>Results of "Grep Pages"</h1>
<hr>
_HTML_

##
# Get the parameters
##
$request_method="$ENV{'REQUEST_METHOD'}";

$l=0;
while (<STDIN>) {
	$l++;

	@pairs=split(/&/,$_);
	foreach $pair (@pairs) {
		if ($pair=~/^Keywords/i) {
			$pair=substr($pair,9);
			@keywords = split(/\+/, $pair);
		}
		if ($pair=~/^All\-OR/i) {
			$all_OR = 1 if (substr($pair, 7)=~/on/i);
		}
		if ($pair=~/^URL/i) {
			$url=substr($pair, 4);
			$url =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;

			if (!($url=~/^$/)) {
				$targets[$target_N] = $url; ++$target_N;
			}
		}
		if ($pair=~/WithoutDefaultURLlist/i) {
			$without_URL_list = 1
				if (substr($pair, 12)=~/on/i);
		}
	}
}

$keywords_N = 0;
foreach $keyword (@keywords) { ++$keywords_N; }

if ($without_URL_list == 0) {
	## Get Default URLs
	open f, $default_url_list
		or die "couldn't open $default_url_list: $!";
	while (<f>) {
		$targets[$target_N] = $_; ++$target_N;
	}
	close f;
}

##
# Send back the parameters
##
print "<h2>Parameters: ";
##print "(REQUEST_METHOD is $request_method)";
print "</h2><ul>\n\n";

print "<li>";
if ($keywords_N > 0) {
	print "$keywords_N KEYWORD";
	if ($keywords_N > 1) {
		print "S";
	}
	print ": <i>";
	foreach $keyword (@keywords) {
		print "$keyword ";
	}
	print "</i><br>";
} else {
	print "<font color=\"red\"><i>Keywords field was empty. ";
	print "Please, Type Several Keywords!</i></font><br>";
}
print "</li>\n\n";

print "<li>Searching Mode: <i>";
if ($all_OR == 1) {
	print "OR";
} else {
	print "AND";
}
print "</i>.</li><br>\n\n";

print "<li>Target URL is <i>";
if ($url =~ /^$/){
	print "NOTHING";
} else {
	print "$url";
}
print "</i>.</li><br>\n\n";

print "<li>";
if ($without_URL_list == 1) {
	print "The default targets are <i>IGNORED</i>.";
} else {
	print "<a href=\"$url_of_default_url_list\">";
	print "<i>Default Targets</i></a>";
}
print "</li>\n\n";

print "</ul><hr>\n\n";

##
# Grep Loop
##
for ($i = 0; $i < $target_N; ++$i) {
	##
	# Open the N-th target (URL or server file)
	##
	if ($targets[$i]=~/^\//) {
		open f, $targets[$i];
		##
		# Establish the TCP connection to site of the URL.
		##

		##
		# Send the request to the site
		##

		##
		# Skip the headers
		##
	} else {
		##
		# Illegal target
		##
		print "<i><font color=\"red\">";
		print "Not implemented how to access $targets[$i], ";
		print "Soory</font></i>\n\n";
		goto CONT;
	}

	##
	# Read the each line from the stream "f"
	##
	$matched_lines[$i] = "";
	while (<f>) {
		##
		# Grep keywords for the line
		##
		$matched = 0;
		foreach $keyword (@keywords) {
			if ($_ =~ /$keyword/) {
				++$matched;
			}
		}
		if (($matched == $keywords_N && $all_OR == 0)
		|| ($matched > 0 && $all_OR == 1)) {
			$x = $_;
			$x =~ s/\</\&lt;/g;
			$x =~ s/\>/\&gt;/g;
			$y = $matched_lines[$i];
			$matched_lines[$i] = "$y<li>$x</li>";
		}
	}

	close f;
CONT:
}

##
# Send back teh results
##
print "<h2>Results:</h2>\n\n";

$j = 0;
for ($i = 0; $i < $target_N; ++$i) {
	if ($matched_lines[$i] =~ /^<li>/) {
		print "<ol>\n\n" if ($j == 0);
		print "<p><li>$targets[$i]<ul>\n\n";
		print "$matched_lines[$i]</ul></li>\n\n";
		++$j;
	}
}
if ($j == 0) {
	print "<blockquote>";
	print "<font color=\"red\"><i>No page is greped.</i></font>";
	print "</blockquote>\n\n";
} else {
	print "</ol>";
}

print "<hr></td></tr></table></body></html>";

exit;

